## libgpuarray 0.6.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

PROJECT(libgpuarray C)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMakeModules/")

# -Wall is unbelieveably noisy with Visual Studio:
# https://stackoverflow.com/q/4001736/3257826
if(MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -W3")
else()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-unused-parameter -Werror=format-security -Wdeclaration-after-statement -std=gnu89")
endif()

enable_testing()

execute_process(COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_SOURCE_DIR}/lib)
set(LIBRARY_OUTPUT_PATH ${CMAKE_SOURCE_DIR}/lib)

set(CMAKE_OSX_ARCHITECTURES x86_64)
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

# Make recent cmake not spam about stuff
if(POLICY CMP0063)
    cmake_policy(SET CMP0063 OLD)
endif()

add_subdirectory(src)
add_subdirectory(tests)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

=== src/CMakeLists.txt ===
include(CheckFunctionExists)

set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DDEBUG")
if(CMAKE_COMPILER_IS_GNUCC)
  add_definitions(-Wdeclaration-after-statement)
endif()

include_directories("${CMAKE_CURRENT_SOURCE_DIR}")

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/gpuarray_types.c
         ${CMAKE_CURRENT_SOURCE_DIR}/gpuarray/types.h
  COMMAND python gen_types.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gen_types.py)

macro (set_rel var)
  file (RELATIVE_PATH _relPath "${CMAKE_SOURCE_DIR}/src" "${CMAKE_CURRENT_SOURCE_DIR}")
  # clear previous list (if any)
  set(SET_REL_TMP)
  foreach (_src ${ARGN})
    if (_relPath)
      list(APPEND SET_REL_TMP "${_relPath}/${_src}")
    else()
      list(APPEND SET_REL_TMP "${_src}")
    endif()
  endforeach()
  if (_relPath)
    set(${var} ${SET_REL_TMP} PARENT_SCOPE)
  else()
    set(${var} ${SET_REL_TMP})
  endif()
endmacro()

set(_GPUARRAY_SRC
cache/lru.c
cache/twoq.c
cache/disk.c
gpuarray_types.c
gpuarray_error.c
gpuarray_util.c
gpuarray_buffer.c
gpuarray_buffer_blas.c
gpuarray_buffer_collectives.c
gpuarray_array.c
gpuarray_array_blas.c
gpuarray_array_collectives.c
gpuarray_kernel.c
gpuarray_extension.c
gpuarray_elemwise.c
gpuarray_reduction.c
gpuarray_buffer_cuda.c
gpuarray_blas_cuda_cublas.c
gpuarray_collectives_cuda_nccl.c
gpuarray_buffer_opencl.c
gpuarray_blas_opencl_clblas.c
gpuarray_blas_opencl_clblast.c
)

check_function_exists(strlcat HAVE_STRL)
check_function_exists(mkstemp HAVE_MKSTEMP)

if(UNIX)
  add_definitions(-D_GNU_SOURCE)
endif()

if(NOT HAVE_STRL)
  list(APPEND _GPUARRAY_SRC gpuarray_strl.c)
endif()

if(NOT HAVE_MKSTEMP)
  list(APPEND _GPUARRAY_SRC gpuarray_mkstemp.c)
endif()

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/private_config.h.in
  ${CMAKE_CURRENT_SOURCE_DIR}/private_config.h
  )

add_subdirectory(util)
add_subdirectory(loaders)

set_rel(GPUARRAY_SRC ${_GPUARRAY_SRC})
list(APPEND GPUARRAY_SRC ${UTIL_SRC} ${LOADERS_SRC})

add_library(gpuarray SHARED ${GPUARRAY_SRC})
set_target_properties(gpuarray PROPERTIES
  COMPILE_FLAGS "-DGPUARRAY_BUILDING_DLL -DGPUARRAY_SHARED"
  INSTALL_NAME_DIR ${CMAKE_INSTALL_PREFIX}/lib
  MACOSX_RPATH OFF
  # This is the shared library version
  VERSION 2.1
  )

add_library(gpuarray-static STATIC ${GPUARRAY_SRC})

target_link_libraries(gpuarray ${CMAKE_DL_LIBS})
target_link_libraries(gpuarray-static ${CMAKE_DL_LIBS})

# Generate gpuarray/abi_version.h that contains the ABI version number.
get_target_property(GPUARRAY_ABI_VERSION gpuarray VERSION)
string(REPLACE "." ";" GPUARRAY_ABI_VERSION_NUMBERS ${GPUARRAY_ABI_VERSION})
list(GET GPUARRAY_ABI_VERSION_NUMBERS 0 GPUARRAY_ABI_VERSION_MAJOR)
list(GET GPUARRAY_ABI_VERSION_NUMBERS 1 GPUARRAY_ABI_VERSION_MINOR)
math(EXPR GPUARRAY_ABI_NUMBER "1000*${GPUARRAY_ABI_VERSION_MAJOR} + ${GPUARRAY_ABI_VERSION_MINOR}")
FILE(WRITE gpuarray/abi_version.h
"\#ifndef GPUARRAY_ABI_VERSION\n\#define GPUARRAY_ABI_VERSION ${GPUARRAY_ABI_NUMBER}\n\#endif\n"
)

# set SOVERSION and ensure it is the first part of VERSION.
set_property(TARGET gpuarray PROPERTY SOVERSION ${GPUARRAY_ABI_VERSION_MAJOR})

set(headers
  gpuarray/array.h
  gpuarray/blas.h
  gpuarray/collectives.h
  gpuarray/buffer.h
  gpuarray/buffer_blas.h
  gpuarray/buffer_collectives.h
  gpuarray/abi_version.h
  gpuarray/config.h
  gpuarray/elemwise.h
  gpuarray/error.h
  gpuarray/extension.h
  gpuarray/ext_cuda.h
  gpuarray/kernel.h
  gpuarray/types.h
  gpuarray/util.h
)

install(FILES ${headers} DESTINATION include/gpuarray)

if(NOT UNIX)
  install(FILES gpuarray/wincompat/stdint.h DESTINATION include/gpuarray/wincompat)
endif()

install(TARGETS gpuarray gpuarray-static
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

=== tests/CMakeLists.txt ===
include(CheckCSourceCompiles)
include(CheckLibraryExists)
find_package(PkgConfig)

pkg_search_module(CHECK check)

if(CHECK_FOUND)
 if(CHECK_VERSION VERSION_LESS 0.10.0)
        MESSAGE( "Check version older than 0.10.0" )
        set(CHECK_FOUND 0)
 endif()
else()
  find_path(CHECK_INCLUDE_DIRS check.h)
  find_library(CHECK_LIBRARIES NAMES check)
  if(CHECK_INCLUDE_DIRS AND CHECK_LIBRARIES)
    set(CHECK_CFLAGS)
    set(CHECK_LIBRARY_DIRS)
    set(CHECK_FOUND 1)
  endif()
  if(CHECK_FOUND)
    set(CMAKE_REQUIRED_FLAGS ${CHECK_C_FLAGS} ${CHECK_LDFLAGS_OTHERS})
    set(CMAKE_REQUIRED_INCLUDES ${CHECK_INCLUDE_DIRS})
    CHECK_LIBRARY_EXISTS(pthread pthread_create "" HAVE_PTHREAD)
    if (HAVE_PTHREAD)
      set(CHECK_LIBRARIES ${CHECK_LIBRARIES} pthread)
    endif (HAVE_PTHREAD)
    CHECK_LIBRARY_EXISTS(rt nanosleep "" HAVE_LIBRT)
    if (HAVE_LIBRT)
      set(CHECK_LIBRARIES ${CHECK_LIBRARIES} rt)
    endif (HAVE_LIBRT)
    CHECK_LIBRARY_EXISTS(m cos "" HAVE_LIBM)
    if (HAVE_LIBM)
      set(CHECK_LIBRARIES ${CHECK_LIBRARIES} m)
    endif (HAVE_LIBM)
    set(CMAKE_REQUIRED_LIBRARIES ${CHECK_LIBRARIES})
    CHECK_C_SOURCE_COMPILES(
      "#include <check.h>
       int main() {
         ck_assert_ptr_ne(NULL, NULL);
       }"
      CHECK_FUNCS)
    if (NOT CHECK_FUNCS)
      set(CHECK_FOUND 0)
    endif()
  endif()
endif()

if(CHECK_FOUND)
enable_testing()

include_directories(${CHECK_INCLUDE_DIRS})
link_directories(${CHECK_LIBRARY_DIRS})

foreach(flag ${CHECK_C_FLAGS})
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${flag}")
endforeach()

foreach(flag ${CHECK_LDFLAGS_OTHER})
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${flag}")
endforeach()

include_directories("${CMAKE_SOURCE_DIR}/src")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}")

add_executable(check_types main.c check_types.c)
target_link_libraries(check_types ${CHECK_LIBRARIES} gpuarray)
add_test(test_types "${CMAKE_CURRENT_BINARY_DIR}/check_types")

add_executable(check_util main.c check_util.c)
target_link_libraries(check_util ${CHECK_LIBRARIES} gpuarray)
add_test(test_util "${CMAKE_CURRENT_BINARY_DIR}/check_util")

add_executable(check_util_integerfactoring main.c check_util_integerfactoring.c)
target_link_libraries(check_util_integerfactoring ${CHECK_LIBRARIES} gpuarray-static)
add_test(test_util_integerfactoring "${CMAKE_CURRENT_BINARY_DIR}/check_util_integerfactoring")

add_executable(check_reduction main.c device.c check_reduction.c)
target_link_libraries(check_reduction ${CHECK_LIBRARIES} gpuarray)
add_test(test_reduction "${CMAKE_CURRENT_BINARY_DIR}/check_reduction")

add_executable(check_array main.c device.c check_array.c)
target_link_libraries(check_array ${CHECK_LIBRARIES} gpuarray)
add_test(test_array "${CMAKE_CURRENT_BINARY_DIR}/check_array")

add_executable(check_blas main.c device.c check_blas.c)
target_link_libraries(check_blas ${CHECK_LIBRARIES} gpuarray)
add_test(test_blas "${CMAKE_CURRENT_BINARY_DIR}/check_blas")

add_executable(check_elemwise main.c device.c check_elemwise.c)
target_link_libraries(check_elemwise ${CHECK_LIBRARIES} gpuarray)
add_test(test_elemwise "${CMAKE_CURRENT_BINARY_DIR}/check_elemwise")

add_executable(check_error main.c check_error.c)
target_link_libraries(check_error ${CHECK_LIBRARIES} gpuarray)
add_test(test_error "${CMAKE_CURRENT_BINARY_DIR}/check_error")

add_executable(check_buffer main.c device.c check_buffer.c)
target_link_libraries(check_buffer ${CHECK_LIBRARIES} gpuarray)
add_test(test_buffer "${CMAKE_CURRENT_BINARY_DIR}/check_buffer")

find_package(MPI)

if (MPI_C_FOUND)

  add_executable(check_buffer_collectives
    main.c device.c communicator.c check_buffer_collectives.c
    )
  target_link_libraries(check_buffer_collectives
    ${CHECK_LIBRARIES} ${MPI_C_LIBRARIES} gpuarray
    )
  target_include_directories(check_buffer_collectives
    PRIVATE ${MPI_C_INCLUDE_PATH}
    )

  add_executable(check_collectives
    main.c device.c communicator.c check_collectives.c
    )
  target_link_libraries(check_collectives
    ${CHECK_LIBRARIES} ${MPI_C_LIBRARIES} gpuarray
    )
  target_include_directories(check_collectives
    PRIVATE ${MPI_C_INCLUDE_PATH}
    )

  set_target_properties(check_buffer_collectives check_collectives PROPERTIES
    COMPILE_DEFINITIONS TEST_COLLECTIVES
    COMPILE_FLAGS "${MPI_C_COMPILE_FLAGS}"
    LINK_FLAGS "${MPI_C_LINK_FLAGS}"
    )

  set(_NUM_DEVS $ENV{NUM_DEVS})
  if(NOT _NUM_DEVS)
    set(_NUM_DEVS 1)
  endif()

  set(_DEV_NAMES $ENV{DEV_NAMES})
  if(NOT _DEV_NAMES)
    set(_DEV_NAMES "cuda")
  endif()
  separate_arguments(_DEV_NAMES)

  add_test(NAME test_buffer_collectives
    COMMAND "${MPIEXEC}" ${MPIEXEC_NUMPROC_FLAG} ${_NUM_DEVS} ${MPIEXEC_PREFLAGS}
    "${CMAKE_CURRENT_BINARY_DIR}/check_buffer_collectives" ${MPIEXEC_POSTFLAGS} ${_DEV_NAMES})
  add_test(NAME test_collectives
    COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} ${_NUM_DEVS} ${MPIEXEC_PREFLAGS}
    "${CMAKE_CURRENT_BINARY_DIR}/check_collectives" ${MPIEXEC_POSTFLAGS} ${_DEV_NAMES})

else()

  message(WARNING "Cannot find MPI")
  message(WARNING "Checks on collectives and buffer_collectives will not be built or performed.")

endif()

ELSE(CHECK_FOUND)

MESSAGE("Tests disabled because Check was not found")

ENDIF(CHECK_FOUND)

=== debian/changelog ===
libgpuarray (0.6.9-2ubuntu5) artful; urgency=medium

  * No-change rebuild to drop _PyFPE support.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 05 Sep 2017 08:21:45 +0000

libgpuarray (0.6.9-2ubuntu4) artful; urgency=medium

  * And fix a wrong import so that the test suite actually passes on
    x86...

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 29 Aug 2017 17:05:29 -0700

libgpuarray (0.6.9-2ubuntu3) artful; urgency=medium

  * Also make the autopkgtest dependency on pocl conditional on
    architecture.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 29 Aug 2017 13:46:59 -0700

libgpuarray (0.6.9-2ubuntu2) artful; urgency=medium

  * Skip autopkgtests on !amd64 !i386, since opencl isn't available.
  * debian/patches/skip-cuda-tests: Add skips for a number of additional
    tests on i386.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 29 Aug 2017 19:30:32 +0000

libgpuarray (0.6.9-2ubuntu1) artful; urgency=medium

  * debian/patches/skip-cuda-tests: skip those tests that we know will
    fail on opencl.  Closes: #870128.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 28 Aug 2017 23:30:28 -0700

libgpuarray (0.6.9-2build1) artful; urgency=medium

  * No-change rebuild to build to drop python3.5.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 05 Aug 2017 16:29:35 +0000

libgpuarray (0.6.9-2) unstable; urgency=medium

  * Fix empty section in documentation
    - Set LD_LIBRARY_PATH before building the docs
    - Add missing build dependency on python3-mako
    Thanks to Daniel Stender for reporting (Closes: #869786)
  * Add autopkgtest suite with pocl

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 26 Jul 2017 21:25:20 +0100

libgpuarray (0.6.9-1) unstable; urgency=medium

  * Add versioned dependency to cython.
    Thanks to Aaron M. Ucko (Closes: #868991)
  * New upstream version 0.6.9 (Closes: #868877)
  * Build extension modules before the docs
  * Normalize the preamble of the rules file

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 26 Jul 2017 00:03:54 +0100

libgpuarray (0.6.8-1) unstable; urgency=medium

  * Upgrade watch file to version 4
  * Update the gbp configuration
  * New upstream version 0.6.8 (Closes: #858401)
  * Drop the patch queue, no longer required
  * Run cme fix on control file
    - Wrap and sort fields and dependencies
    - Bump standards version to 4.0.0
  * Run cme fix on copyright file
    - Use secure Format URI
    - Sort the copyright sections
    - Normalize the license paragraphs
  * Bump debhelper to version 10
  * Bump soversion to 2
  * Use pybuild as default build system
  * Clean the generated version file
  * Normalize the package descriptions
  * Run dh_numpy within dh_python overrides
  * Provide debug packages for Python
  * Provide a documentation package
  * Update build and install dependencies
    - Drop libclblas-dev and opencl-dev from Build-Depends, not required
    - Drop nose from Recommends, not required
  * Filter egg-info dir using extend-diff-ignore
  * Use the default Python autopkgtest suite
  * Adopt the package
    - Transfer maintenance to the Debian Science Team
    - Add myself to Uploaders
    - Add myself to copyright (Closes: #852137)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Mon, 17 Jul 2017 10:02:36 +0100

libgpuarray (0.0+git160929.29ce960-1) experimental; urgency=medium

  * Initial release (Closes: #819012).

 -- Daniel Stender <stender@debian.org>  Mon, 03 Oct 2016 15:11:12 +0200

=== debian/control ===
Source: libgpuarray
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake,
               cython (>= 0.25),
               cython-dbg,
               cython3 (>= 0.25),
               cython3-dbg,
               debhelper (>= 10),
               dpkg-dev (>= 1.17.14),
               dh-python,
               python-all-dbg,
               python-all-dev,
               python-numpy,
               python-numpy-dbg,
               python-setuptools,
               python3-all-dbg,
               python3-all-dev,
               python3-numpy,
               python3-numpy-dbg,
               python3-setuptools,
               sphinx-common
Build-Depends-Indep: python3-breathe <!nodoc>,
                     python3-mako <!nodoc>,
                     python3-sphinx <!nodoc>,
                     python3-sphinx-rtd-theme <!nodoc>
Standards-Version: 4.0.0
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/libgpuarray.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/libgpuarray.git
Homepage: https://github.com/Theano/libgpuarray

Package: libgpuarray2
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: library to manipulate tensors on the GPU
 libgpuarray provides a ndarray (multi-dimensional array) object which
 is computed on the GPU. It supports int, single and double precision
 floats.
 .
 libgpuarray supports Nvidia's CUDA interface as well as OpenCL. The
 Debian packages have been build against OpenCL. However, the source
 package could be rebuild locally also for CUDA (which is non-free)
 without changes, if that's needed.
 .
 This package provides the shared library.

Package: libgpuarray-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libgpuarray2 (= ${binary:Version})
Suggests: libgpuarray-doc <!nodoc>
Description: development files for libgpuarray
 libgpuarray provides a ndarray (multi-dimensional array) object which
 is computed on the GPU. It supports int, single and double precision
 floats.
 .
 libgpuarray supports Nvidia's CUDA interface as well as OpenCL. The
 Debian packages have been build against OpenCL. However, the source
 package could be rebuild locally also for CUDA (which is non-free)
 without changes, if that's needed.
 .
 This package provides the development files.

Package: libgpuarray-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Description: documentation for libgpuarray
 libgpuarray provides a ndarray (multi-dimensional array) object which
 is computed on the GPU. It supports int, single and double precision
 floats.
 .
 libgpuarray supports Nvidia's CUDA interface as well as OpenCL. The
 Debian packages have been build against OpenCL. However, the source
 package could be rebuild locally also for CUDA (which is non-free)
 without changes, if that's needed.
 .
 This package provides the documentation.
Build-Profiles: <!nodoc>

Package: python-pygpu
Architecture: any
Section: python
Depends: ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
         libgpuarray2 (= ${binary:Version})
Suggests: libgpuarray-doc <!nodoc>
Description: language bindings for libgpuarray (Python 2)
 libgpuarray provides a ndarray (multi-dimensional array) object which
 is computed on the GPU. It supports int, single and double precision
 floats.
 .
 libgpuarray supports Nvidia's CUDA interface as well as OpenCL. The
 Debian packages have been build against OpenCL. However, the source
 package could be rebuild locally also for CUDA (which is non-free)
 without changes, if that's needed.
 .
 This package provides the language bindings for Python 2.

Package: python-pygpu-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
         python-numpy-dbg,
         python-pygpu (= ${binary:Version})
Description: debug extensions for pygpu (Python 2)
 libgpuarray provides a ndarray (multi-dimensional array) object which
 is computed on the GPU. It supports int, single and double precision
 floats.
 .
 libgpuarray supports Nvidia's CUDA interface as well as OpenCL. The
 Debian packages have been build against OpenCL. However, the source
 package could be rebuild locally also for CUDA (which is non-free)
 without changes, if that's needed.
 .
 This package provides the debug extensions for Python 2.

Package: python3-pygpu
Architecture: any
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         libgpuarray2 (= ${binary:Version})
Suggests: libgpuarray-doc <!nodoc>
Description: language bindings for libgpuarray (Python 3)
 libgpuarray provides a ndarray (multi-dimensional array) object which
 is computed on the GPU. It supports int, single and double precision
 floats.
 .
 libgpuarray supports Nvidia's CUDA interface as well as OpenCL. The
 Debian packages have been build against OpenCL. However, the source
 package could be rebuild locally also for CUDA (which is non-free)
 without changes, if that's needed.
 .
 This package provides the language bindings for Python 3.

Package: python3-pygpu-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
         python3-numpy-dbg,
         python3-pygpu (= ${binary:Version})
Description: debug extensions for pygpu (Python 3)
 libgpuarray provides a ndarray (multi-dimensional array) object which
 is computed on the GPU. It supports int, single and double precision
 floats.
 .
 libgpuarray supports Nvidia's CUDA interface as well as OpenCL. The
 Debian packages have been build against OpenCL. However, the source
 package could be rebuild locally also for CUDA (which is non-free)
 without changes, if that's needed.
 .
 This package provides the debug extensions for Python 3.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

export PYBUILD_NAME=pygpu
export PYBUILD_SYSTEM=distutils
export PYBUILD_BEFORE_BUILD={interpreter} setup.py build_ext -b {build_dir} -I $(CURDIR)/src -L $(CURDIR)/lib
export PYBUILD_AFTER_INSTALL_python2-dbg=rm -f {destdir}/{install_dir}/pygpu/*.h
export PYBUILD_AFTER_INSTALL_python3-dbg=rm -f {destdir}/{install_dir}/pygpu/*.h

%:
	dh $@ --with python2,python3,sphinxdoc --buildsystem=pybuild

override_dh_auto_clean-arch:
	dh_auto_clean --buildsystem=cmake
	dh_auto_clean

override_dh_auto_clean-indep:
ifeq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
	find $(CURDIR) -type f -name ".so" -delete
	$(MAKE) -C doc clean
endif

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake
	dh_auto_configure

override_dh_auto_build-arch:
	dh_auto_build --buildsystem=cmake
	dh_auto_build

override_dh_auto_build-indep: export http_proxy=127.0.0.1:9
override_dh_auto_build-indep: export https_proxy=127.0.0.1:9
override_dh_auto_build-indep:
ifeq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
	python3 setup.py build_ext --inplace -I $(CURDIR)/src -L $(CURDIR)/lib
	LD_LIBRARY_PATH=$(CURDIR)/lib PYTHONPATH=$(CURDIR) $(MAKE) -C doc html
endif

override_dh_auto_test:

override_dh_auto_install:
	dh_auto_install --buildsystem=cmake
	dh_auto_install

override_dh_python2:
	dh_python2
	dh_numpy

override_dh_python3:
	dh_python3
	dh_numpy3

override_dh_strip-arch:
	dh_strip --package=python-$(PYBUILD_NAME) \
		--dbg-package=python-$(PYBUILD_NAME)-dbg
	dh_strip --package=python3-$(PYBUILD_NAME) \
		--dbg-package=python3-$(PYBUILD_NAME)-dbg
	dh_strip --arch

=== debian/tests/control ===
Test-Command: set -e
 ; case $(dpkg --print-architecture) in amd64|i386) ;; *) exit 0 ;; esac
 ; for py in $(pyversions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; DEVICE=opencl0:0 $py -m nose pygpu
 ; echo "Testing with $py-dbg:"
 ; DEVICE=opencl0:0 $py-dbg -m nose pygpu
 ; done
Depends: ocl-icd-opencl-dev,
         pocl-opencl-icd [amd64 i386],
         python-all,
         python-all-dbg,
         python-nose,
         python-pygpu,
         python-pygpu-dbg
Restrictions: allow-stderr

Test-Command: set -e
 ; case $(dpkg --print-architecture) in amd64|i386) ;; *) exit 0 ;; esac
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; DEVICE=opencl0:0 $py -m nose pygpu
 ; echo "Testing with $py-dbg:"
 ; DEVICE=opencl0:0 $py-dbg -m nose pygpu
 ; done
Depends: ocl-icd-opencl-dev,
         pocl-opencl-icd [amd64 i386],
         python3-all,
         python3-all-dbg,
         python3-nose,
         python3-pygpu,
         python3-pygpu-dbg
Restrictions: allow-stderr

## libgpuarray 0.7.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 if(MSVC)
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -W3")
 else()
-    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-unused-parameter -Werror=format-security -Wdeclaration-after-statement -std=gnu89")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wno-unused-parameter -Werror=format-security -Wdeclaration-after-statement -std=gnu89")
 endif()
 
 enable_testing()

=== Makefile ===
rel: install-relc py

-include Makefile.conf

config: Makefile.conf

Makefile.conf:
	@[ ! -f Makefile.conf ] && cp Makefile.conf.tmpl Makefile.conf && echo "\n\n** Adjust the values in Makefile.conf for your system **\n\n" && exit 1

debug: install-debugc py

.PHONY: install-debugc py debug install-relc rel config

Debug/Makefile: Makefile.conf
	mkdir -p Debug
ifndef INSTALL_PREFIX
	(cd Debug && NUM_DEVS=${NUM_DEVS} DEV_NAMES=${DEV_NAMES} cmake .. -DCMAKE_BUILD_TYPE=Debug)
else
	(cd Debug && NUM_DEVS=${NUM_DEVS} DEV_NAMES=${DEV_NAMES} cmake .. -DCMAKE_BUILD_TYPE=Debug -DCMAKE_INSTALL_PREFIX=$(INSTALL_PREFIX))
endif

debugc: Debug/Makefile
	(cd Debug && make)

test-debugc: debugc
ifndef DEVICE
	(cd Debug && make test)
else
	(cd Debug && DEVICE=${DEVICE} make test)
endif

install-debugc: debugc
	(cd Debug && ${SUDO} make install)

Release/Makefile: Makefile.conf
	mkdir -p Release
ifndef INSTALL_PREFIX
	(cd Release && NUM_DEVS=${NUM_DEVS} DEV_NAMES=${DEV_NAMES} cmake .. -DCMAKE_BUILD_TYPE=Release)
else
	(cd Release && NUM_DEVS=${NUM_DEVS} DEV_NAMES=${DEV_NAMES} cmake .. -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=$(INSTALL_PREFIX))
endif

relc: Release/Makefile
	(cd Release && make)

test-relc: relc
ifndef DEVICE
	(cd Release && make test)
else
	(cd Release && DEVICE=${DEVICE} make test)
endif

install-relc: relc
	(cd Release && ${SUDO} make install)

py: Makefile.conf
	python setup.py build_ext --inplace

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

DOXYGEN	      = doxygen
# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .


.PHONY: help clean doxy html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

doxy:
	($(DOXYGEN) Doxyfile || /Applications/Doxygen.app/Contents/Resources/doxygen Doxyfile)

html: doxy
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml: doxy
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml: doxy
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle: doxy
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json: doxy
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp: doxy
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp: doxy
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/gpuarray.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/gpuarray.qhc"

devhelp: doxy
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/gpuarray"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/gpuarray"
	@echo "# devhelp"

epub: doxy
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex: doxy
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf: doxy
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text: doxy
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man: doxy
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo: doxy
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info: doxy
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext: doxy
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,22 @@
   COMMAND python gen_types.py
   WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
   DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gen_types.py)
+
+add_custom_command(
+  OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/cluda_cuda.h.c
+  COMMAND python head.py cluda_cuda.h
+  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/head.py
+          ${CMAKE_CURRENT_SOURCE_DIR}/cluda_cuda.h
+  )
+
+add_custom_command(
+  OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/cluda_opencl.h.c
+  COMMAND python head.py cluda_opencl.h
+  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/head.py
+          ${CMAKE_CURRENT_SOURCE_DIR}/cluda_opencl.h
+  )
 
 macro (set_rel var)
   file (RELATIVE_PATH _relPath "${CMAKE_SOURCE_DIR}/src" "${CMAKE_CURRENT_SOURCE_DIR}")
@@ -57,6 +73,9 @@
 gpuarray_blas_opencl_clblast.c
 )
 
+set_property(SOURCE gpuarray_buffer_cuda.c APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/cluda_cuda.h.c)
+set_property(SOURCE gpuarray_buffer_opencl.c APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/cluda_opencl.h.c)
+
 check_function_exists(strlcat HAVE_STRL)
 check_function_exists(mkstemp HAVE_MKSTEMP)
 
@@ -89,7 +108,7 @@
   INSTALL_NAME_DIR ${CMAKE_INSTALL_PREFIX}/lib
   MACOSX_RPATH OFF
   # This is the shared library version
-  VERSION 2.1
+  VERSION 3.0
   )
 
 add_library(gpuarray-static STATIC ${GPUARRAY_SRC})

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -48,6 +48,9 @@
 if(CHECK_FOUND)
 enable_testing()
 
+include_directories("${CMAKE_SOURCE_DIR}/src")
+include_directories("${CMAKE_CURRENT_SOURCE_DIR}")
+
 include_directories(${CHECK_INCLUDE_DIRS})
 link_directories(${CHECK_LIBRARY_DIRS})
 
@@ -58,9 +61,6 @@
 foreach(flag ${CHECK_LDFLAGS_OTHER})
   set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${flag}")
 endforeach()
-
-include_directories("${CMAKE_SOURCE_DIR}/src")
-include_directories("${CMAKE_CURRENT_SOURCE_DIR}")
 
 add_executable(check_types main.c check_types.c)
 target_link_libraries(check_types ${CHECK_LIBRARIES} gpuarray)

=== src/loaders/CMakeLists.txt ===
set_rel(LOADERS_SRC
dyn_load.c
libcuda.c
libnvrtc.c
libcublas.c
libnccl.c
libopencl.c
libclblas.c
libclblast.c
)

=== src/util/CMakeLists.txt ===
set_rel(UTIL_SRC
strb.c
error.c
xxhash.c
integerfactoring.c
skein.c
)

=== debian/changelog ===
libgpuarray (0.7.6-3) unstable; urgency=medium

  * tests: add missing MPI dependency.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Fri, 08 Feb 2019 22:08:33 +0000

libgpuarray (0.7.6-2) unstable; urgency=medium

  * Mark tests skip-not-installable.
  * tests: remove no longer needed #919824 workaround,
    and add one for #877316.
  * Upload to unstable.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Thu, 07 Feb 2019 20:06:05 +0000

libgpuarray (0.7.6-1) experimental; urgency=medium

  * New upstream release.  (Closes: #901487)
  * Upload to experimental, as this is a soname change (but was
    ruled not a transition, i.e. not currently frozen, in #919022).
  * Drop patch applied upstream.
  * Rebuild generated *.h.c.
  * More user-friendly error when double precision is not available,
    and treat this as a skip not a fail in tests.
  * Fix lru_cache corruption exception.
  * Fix stack smashing crash in *gemmBatch.
  * Update copyright year.
  * Include the BLAS and mpi4py tests in autopkgtest,
    and apply workarounds for #919824 and #920497.
  * tests: enable verbose output, don't run the same tests twice.
  * Fix typo in error message.
  * Fix bug in BLAS error reporting.
  * Fail tril/triu of doubles instead of returning nonsense.
  * Fix intermittent test_dot failure.
  * Remove build path from assert messages (for reproducibility).

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Tue, 29 Jan 2019 19:38:23 +0000

libgpuarray (0.6.9-3) unstable; urgency=medium

  * Add myself to Uploaders.
  * Fix FTBFS when building only arch:all.  (Closes: #901111)
  * Make python3-pygpu-dbg depend on Python 3, not 2.
    Thanks to Adrian Bunk  (Closes: #906100)
  * Use to-nearest-even rounding in half precision operations.
  * Fix crash in extract_triu/l.
  * Skip CUDA-only tests on OpenCL.  (Closes: #870128)
  * Update Vcs-* for move to Salsa.
  * Stop using priority extra to comply with Standards-Version 4.3.0.
  * Depend or Recommend the libraries we try to dlopen().
  * Set Rules-Requires-Root: no.
  * Fix spelling in documentation and error messages.
  * Update d/copyright.
  * Rebuild generated C files.
  * Add d/upstream/metadata.
  * Bump debhelper compat to 11, and update doc-base links.
  * Fix clGetDeviceInfo exception on 32 bit architectures.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Tue, 15 Jan 2019 22:18:47 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: libgpuarray
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>,
+ Rebecca N. Palmer <rebecca_palmer@zoho.com>
 Section: libs
 Priority: optional
 Build-Depends: cmake,
@@ -9,7 +9,7 @@
                cython-dbg,
                cython3 (>= 0.25),
                cython3-dbg,
-               debhelper (>= 10),
+               debhelper (>= 11),
                dpkg-dev (>= 1.17.14),
                dh-python,
                python-all-dbg,
@@ -22,20 +22,25 @@
                python3-numpy,
                python3-numpy-dbg,
                python3-setuptools,
-               sphinx-common
+               sphinx-common,
+               python-mako
 Build-Depends-Indep: python3-breathe <!nodoc>,
                      python3-mako <!nodoc>,
                      python3-sphinx <!nodoc>,
                      python3-sphinx-rtd-theme <!nodoc>
-Standards-Version: 4.0.0
-Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/libgpuarray.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/libgpuarray.git
+Standards-Version: 4.3.0
+Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/science-team/libgpuarray
+Vcs-Git: https://salsa.debian.org/science-team/libgpuarray.git
 Homepage: https://github.com/Theano/libgpuarray
 
-Package: libgpuarray2
+Package: libgpuarray3
 Architecture: any
 Depends: ${misc:Depends},
-         ${shlibs:Depends}
+         ${shlibs:Depends},
+#need the -dev because it dlopen()s the un-numbered names
+         ocl-icd-opencl-dev | nvidia-cuda-dev
+Recommends: libclblas-dev | nvidia-cuda-dev
 Description: library to manipulate tensors on the GPU
  libgpuarray provides a ndarray (multi-dimensional array) object which
  is computed on the GPU. It supports int, single and double precision
@@ -52,7 +57,7 @@
 Architecture: any
 Section: libdevel
 Depends: ${misc:Depends},
-         libgpuarray2 (= ${binary:Version})
+         libgpuarray3 (= ${binary:Version})
 Suggests: libgpuarray-doc <!nodoc>
 Description: development files for libgpuarray
  libgpuarray provides a ndarray (multi-dimensional array) object which
@@ -92,7 +97,7 @@
 Depends: ${misc:Depends},
          ${python:Depends},
          ${shlibs:Depends},
-         libgpuarray2 (= ${binary:Version})
+         libgpuarray3 (= ${binary:Version})
 Suggests: libgpuarray-doc <!nodoc>
 Description: language bindings for libgpuarray (Python 2)
  libgpuarray provides a ndarray (multi-dimensional array) object which
@@ -109,7 +114,6 @@
 Package: python-pygpu-dbg
 Architecture: any
 Section: debug
-Priority: extra
 Depends: ${misc:Depends},
          ${python:Depends},
          ${shlibs:Depends},
@@ -133,7 +137,7 @@
 Depends: ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends},
-         libgpuarray2 (= ${binary:Version})
+         libgpuarray3 (= ${binary:Version})
 Suggests: libgpuarray-doc <!nodoc>
 Description: language bindings for libgpuarray (Python 3)
  libgpuarray provides a ndarray (multi-dimensional array) object which
@@ -150,9 +154,8 @@
 Package: python3-pygpu-dbg
 Architecture: any
 Section: debug
-Priority: extra
 Depends: ${misc:Depends},
-         ${python:Depends},
+         ${python3:Depends},
          ${shlibs:Depends},
          python3-numpy-dbg,
          python3-pygpu (= ${binary:Version})

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,7 @@
 #export DH_VERBOSE=1
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow
+export DEB_CPPFLAGS_MAINT_APPEND=-fmacro-prefix-map=$(CURDIR)=.
 
 export PYBUILD_NAME=pygpu
 export PYBUILD_SYSTEM=distutils
@@ -25,6 +26,8 @@
 endif
 
 override_dh_auto_configure:
+	#force generated files in source to be rebuilt
+	rm -f src/gpuarray/types.h src/gpuarray_types.c src/cluda_cuda.h.c src/cluda_opencl.h.c
 	dh_auto_configure --buildsystem=cmake
 	dh_auto_configure
 
@@ -36,15 +39,19 @@
 override_dh_auto_build-indep: export https_proxy=127.0.0.1:9
 override_dh_auto_build-indep:
 ifeq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
+	#can't build the documentation without first building the library - #901111
+	dh_auto_build --buildsystem=cmake
 	python3 setup.py build_ext --inplace -I $(CURDIR)/src -L $(CURDIR)/lib
 	LD_LIBRARY_PATH=$(CURDIR)/lib PYTHONPATH=$(CURDIR) $(MAKE) -C doc html
 endif
 
 override_dh_auto_test:
 
-override_dh_auto_install:
+override_dh_auto_install-arch:
 	dh_auto_install --buildsystem=cmake
 	dh_auto_install
+
+override_dh_auto_install-indep:
 
 override_dh_python2:
 	dh_python2

=== debian/tests/control ===
# Tests are run on the first OpenCL platform/device: to run them on a real GPU (instead of the CPU), manually install its ICD before running this

Test-Command: set -e
 ; for py in $(pyversions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; DEVICE=opencl0:0 $py -m nose -v pygpu.tests
 ; echo "Testing with $py-dbg:"
 ; DEVICE=opencl0:0 $py-dbg -m nose -v pygpu.tests
 ; done
Depends: ocl-icd-opencl-dev,
         pocl-opencl-icd,
         libclblas-dev,
         python-scipy,
         python-mpi4py,
         mpi-default-bin,
         python-all,
         python-all-dbg,
         python-nose,
         python-pygpu,
         python-pygpu-dbg
Restrictions: allow-stderr, skip-not-installable

Test-Command: set -e
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; DEVICE=opencl0:0 $py -m nose -v pygpu.tests
 ; echo "Testing with $py-dbg:"
 ; DEVICE=opencl0:0 $py-dbg -m nose -v pygpu.tests
 ; done
Depends: ocl-icd-opencl-dev,
         pocl-opencl-icd,
         libclblas-dev,
         python3-scipy,
         python3-mpi4py,
         mpi-default-bin,
         python3-all,
         python3-all-dbg,
         python3-nose,
         python3-pygpu,
         python3-pygpu-dbg
Restrictions: allow-stderr, skip-not-installable

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?@ANY_VERSION@\.tar\.gz/libgpuarray-$1\.tar\.gz/ \
https://github.com/Theano/libgpuarray/tags .*/v?@ANY_VERSION@\.tar\.gz
